﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Net.Http.Headers;
using System.Net.Http.Formatting;
using Newtonsoft.Json.Linq;

namespace ConsoleApp1
{
    class Jira
    {
        const string QUERY_URL_FORMAT = "http://{0}/rest/api/2/{1}";
        string _baseUrl;
        CookieContainer _cookies;
        HttpClient _httpClient;

        public async Task<bool> Login(string jiraServer, string userId, string password)
        {
            string url = string.Format(QUERY_URL_FORMAT, jiraServer, "myself");
            string authHeader = CreateBasicAuth(userId, password);

            HttpClientHandler handler = new HttpClientHandler();
            _cookies = new CookieContainer();
            handler.CookieContainer = _cookies;

            HttpClient hc = new HttpClient(handler);

            hc.DefaultRequestHeaders.Add("Authorization", authHeader);

            HttpResponseMessage hrm = await hc.GetAsync(url);
            if (hrm.StatusCode == System.Net.HttpStatusCode.Unauthorized)
            {
                return false;
            }

            _baseUrl = string.Format(QUERY_URL_FORMAT, jiraServer, "");
            _httpClient = hc;

            return true;
        }

        private string CreateBasicAuth(string userId, string password)
        {
            string text = userId + ":" + password;
            byte[] buf = Encoding.UTF8.GetBytes(text);
            return "Basic " + Convert.ToBase64String(buf);
        }
        /*
        public async void CreateIssueTest2()
        {
            string strPosturl = _baseUrl + "issue/";
            HttpClient client = new HttpClient();
            client.BaseAddress = new Uri(_baseUrl +"/ secure/CreateIssueDetails!init.jspa?pid=admin&issuetype=2&summary=New");
            byte[] cred = UTF8Encoding.UTF8.GetBytes("admin:admin");

            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(cred));

            client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
            MediaTypeFormatter jsonFormatter = new JsonMediaTypeFormatter();
            string data = @"{""fields"":{""project"":{""key"": ""SAM""},""summary"": ""REST EXAMPLE"",""description"":""Creating an issue via REST API"",""issuetype"": {""name"": ""Bug""},""mrNumber"": {""name"": ""AnyMrNumber what i will send later""}}}";


            //ObjectContent content = new HttpContent.(ApmData)(data, jsonFormatter);
            var product = new ApmData() { MainRequirementNumber = "Hi Miso" };
            Uri gizmoUri = null;//new Uri ("http://IP:Port/secure/CreateIssueDetails!init.jspa?pid=13839&issuetype=2&assignee=Michal&summary=New&reporter=EMICCRK");

            HttpResponseMessage response = client.PostAsJsonAsync("/secure/CreateIssueDetails!init.jspa?pid=admin&issuetype=1&summary=New&reporter=EKEICUN/", gizmoUri).Result;

            if (response.IsSuccessStatusCode)
            {
                string result = response.Content.ReadAsStringAsync().Result;
                gizmoUri = response.Headers.Location;
                Console.WriteLine("{0} ({1})", (int)response.StatusCode, response.ReasonPhrase);
            }
            else
            {
                Console.WriteLine("{0} ({1})", (int)response.StatusCode, response.ReasonPhrase);
            }
        }
        */
        public async void CreateIssueTest(string projectKey, string assignee, string password)
        {
            string strPosturl = _baseUrl+"issue/";
            HttpClient client = new HttpClient();
            client.BaseAddress = new System.Uri(strPosturl);
            byte[] cred = UTF8Encoding.UTF8.GetBytes("admin:admin");
            client.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", Convert.ToBase64String(cred));
            client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/json"));
            MediaTypeFormatter jsonFormatter = new JsonMediaTypeFormatter();

            string data = "{\n\t\"fields\":{\n\t\t\"project\":\n\t\t{\n\t\t\t\"key\":\"SAM\"\n\t\t},\n\t\t\"summary\": \"Test API\",\n\t\t\"description\": \"Test Description\",\n\t\t\"issuetype\": {\n\t\t\t\"name\": \"Story\"\n\t\t}\n\t}\n}";
            Issue result = Newtonsoft.Json.JsonConvert.DeserializeObject<Issue>(data);
            HttpContent content = new ObjectContent<Issue>(result, jsonFormatter);

//          HttpResponseMessage response = client.PostAsync("/CreateIssueDetails!init.jspa?pid=10123&summary=TESTMAMA&reporter=admin", content).Result;
            HttpResponseMessage response = client.PostAsync("issue", content).Result;
            if (response.IsSuccessStatusCode)
            {
                string strResult = response.Content.ReadAsStringAsync().Result;
                Console.WriteLine(response.StatusCode.ToString());
            }
            else
            {
                Console.WriteLine(response.StatusCode.ToString());
            }
        }

        public async Task<Issue> GetIssue(string IssueID)
        {
            string url = _baseUrl + "issue/"+IssueID ;

            HttpResponseMessage hrm = await _httpClient.GetAsync(url);

            string text = await hrm.Content.ReadAsStringAsync();

            Issue result = Newtonsoft.Json.JsonConvert.DeserializeObject<Issue>(text);
            return result;

        }

        public async Task<SearchResult> SearchIssue(string projectKey, string assignee)
        {
            string url = _baseUrl + "search?jql=assignee=" + assignee + " and project=" + projectKey;

            HttpResponseMessage hrm = await _httpClient.GetAsync(url);

            string text = await hrm.Content.ReadAsStringAsync();

            SearchResult result = Newtonsoft.Json.JsonConvert.DeserializeObject<SearchResult>(text);
            return result;
        }
    }
}
